easy_install pygame не работает из-за ошибки «linux / videodev.h: Нет такого файла или каталога»

9

Попытка установить pygame через easy_install в Ubuntu 12.10 и ошибки, которые она мне дает:

Continuing With "setup.py"
warning: no files found matching 'readme.txt'
no previously-included directories found matching '*/CVS'
no previously-included directories found matching '*/*/CVS'
src/mixer.c: In function ‘chan_set_volume’:
src/mixer.c:660:9: warning: variable ‘result’ set but not used [-Wunused-but-set-  variable]
In file included from /usr/include/python2.7/Python.h:8:0,
             from src/scrap.h:22,
             from src/scrap.c:30:
/usr/include/python2.7/pyconfig.h:1161:0: warning: "_POSIX_C_SOURCE" redefined [enabled by default]
In file included from /usr/include/stdio.h:28:0,
             from src/scrap.c:24:
/usr/include/features.h:215:0: note: this is the location of the previous definition
In file included from src/scrap.c:59:0:
src/scrap_x11.c: In function ‘_get_data_as’:
src/scrap_x11.c:567:17: warning: pointer targets in assignment differ in signedness [-Wpointer-sign]
src/scrap.c: In function ‘initscrap’:
src/scrap.c:329:15: warning: variable ‘mod’ set but not used [-Wunused-but-set-variable]
In file included from src/_camera.c:36:0:
src/camera.h:42:32: fatal error: linux/videodev.h: No such file or directory
compilation terminated.
error: Setup script exited with error: command 'gcc' failed with exit status 1

и работает sudo ln -s /usr/include/linux/videodev2.h /usr/include/linux/videodev.h дает:

Continuing With "setup.py"
warning: no files found matching 'readme.txt'
no previously-included directories found matching '*/CVS'
no previously-included directories found matching '*/*/CVS'
src/mixer.c: In function ‘chan_set_volume’:
src/mixer.c:660:9: warning: variable ‘result’ set but not used [-Wunused-but-set-variable]
In file included from /usr/include/python2.7/Python.h:8:0,
             from src/scrap.h:22,
             from src/scrap.c:30:
/usr/include/python2.7/pyconfig.h:1161:0: warning: "_POSIX_C_SOURCE" redefined [enabled by default]
In file included from /usr/include/stdio.h:28:0,
             from src/scrap.c:24:
/usr/include/features.h:215:0: note: this is the location of the previous definition
In file included from src/scrap.c:59:0:
src/scrap_x11.c: In function ‘_get_data_as’:
src/scrap_x11.c:567:17: warning: pointer targets in assignment differ in signedness [-Wpointer-sign]
src/scrap.c: In function ‘initscrap’:
src/scrap.c:329:15: warning: variable ‘mod’ set but not used [-Wunused-but-set-variable]
In file included from src/camera.h:20:0,
             from src/camera_v4l2.c:22:
src/pygame.h:678:14: warning: ‘PyGAME_C_API’ defined but not used [-Wunused-variable]
src/camera_v4l.c: In function ‘v4l_open_device’:
src/camera_v4l.c:29:29: error: storage size of ‘cap’ isn’t known
src/camera_v4l.c:30:23: error: storage size of ‘buf’ isn’t known
src/camera_v4l.c:51:24: error: ‘VIDIOCGCAP’ undeclared (first use in this function)
src/camera_v4l.c:51:24: note: each undeclared identifier is reported only once for      each function it appears in
src/camera_v4l.c:63:26: error: ‘VIDIOCGMBUF’ undeclared (first use in this function)
src/camera_v4l.c:30:23: warning: unused variable ‘buf’ [-Wunused-variable]
src/camera_v4l.c:29:29: warning: unused variable ‘cap’ [-Wunused-variable]
In file included from src/camera.h:20:0,
             from src/camera_v4l.c:20:
src/camera_v4l.c: At top level:
src/pygame.h:678:14: warning: ‘PyGAME_C_API’ defined but not used [-Wunused-variable]
error: Setup script exited with error: command 'gcc' failed with exit status 1
    
задан JDW 20.10.2012 в 15:31
источник

3 ответа

14

Этот ответ SO обеспечивает правильную символическую ссылку. Вам нужно удалить /usr/include/linux/videodev.h , который вы создали, - это ссылка на неправильную версию файла заголовка.

sudo apt-get install libv4l-dev
cd /usr/include/linux
sudo ln -s ../libv4l1-videodev.h videodev.h
    
ответ дан bstpierre 26.12.2012 в 22:11
3

Pygame нуждается в некоторых зависимостях:

sudo apt-get install python-dev libsdl-image1.2-dev libsdl-mixer1.2-dev libsdl-ttf2.0-dev   libsdl1.2-dev libsmpeg-dev python-numpy subversion libportmidi-dev ffmpeg libswscale-dev libavformat-dev libavcodec-dev

Если вы не хотите их устанавливать, установите предварительно скомпилированный пакет:

sudo apt-get install python-pygame
    
ответ дан mid_kid 21.10.2012 в 18:23
2

Является ли версия pygame в репозиториях ( python-pygame )  слишком старый? Если нет, попробуйте сначала установить это.

В противном случае используйте python-pip для установки pygame :

sudo pip install pygame

Зачем использовать pip над easy_install?     

ответ дан Isaiah 20.10.2012 в 15:40